# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::Logic::Mgmt::V2018_07_01_preview
  module Models
    #
    # The Edifact agreement protocol settings.
    #
    class EdifactProtocolSettings

      include MsRestAzure

      # @return [EdifactValidationSettings] The EDIFACT validation settings.
      attr_accessor :validation_settings

      # @return [EdifactFramingSettings] The EDIFACT framing settings.
      attr_accessor :framing_settings

      # @return [EdifactEnvelopeSettings] The EDIFACT envelope settings.
      attr_accessor :envelope_settings

      # @return [EdifactAcknowledgementSettings] The EDIFACT acknowledgement
      # settings.
      attr_accessor :acknowledgement_settings

      # @return [EdifactMessageFilter] The EDIFACT message filter.
      attr_accessor :message_filter

      # @return [EdifactProcessingSettings] The EDIFACT processing Settings.
      attr_accessor :processing_settings

      # @return [Array<EdifactEnvelopeOverride>] The EDIFACT envelope override
      # settings.
      attr_accessor :envelope_overrides

      # @return [Array<EdifactMessageIdentifier>] The EDIFACT message filter
      # list.
      attr_accessor :message_filter_list

      # @return [Array<EdifactSchemaReference>] The EDIFACT schema references.
      attr_accessor :schema_references

      # @return [Array<EdifactValidationOverride>] The EDIFACT validation
      # override settings.
      attr_accessor :validation_overrides

      # @return [Array<EdifactDelimiterOverride>] The EDIFACT delimiter
      # override settings.
      attr_accessor :edifact_delimiter_overrides


      #
      # Mapper for EdifactProtocolSettings class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'EdifactProtocolSettings',
          type: {
            name: 'Composite',
            class_name: 'EdifactProtocolSettings',
            model_properties: {
              validation_settings: {
                client_side_validation: true,
                required: true,
                serialized_name: 'validationSettings',
                type: {
                  name: 'Composite',
                  class_name: 'EdifactValidationSettings'
                }
              },
              framing_settings: {
                client_side_validation: true,
                required: true,
                serialized_name: 'framingSettings',
                type: {
                  name: 'Composite',
                  class_name: 'EdifactFramingSettings'
                }
              },
              envelope_settings: {
                client_side_validation: true,
                required: true,
                serialized_name: 'envelopeSettings',
                type: {
                  name: 'Composite',
                  class_name: 'EdifactEnvelopeSettings'
                }
              },
              acknowledgement_settings: {
                client_side_validation: true,
                required: true,
                serialized_name: 'acknowledgementSettings',
                type: {
                  name: 'Composite',
                  class_name: 'EdifactAcknowledgementSettings'
                }
              },
              message_filter: {
                client_side_validation: true,
                required: true,
                serialized_name: 'messageFilter',
                type: {
                  name: 'Composite',
                  class_name: 'EdifactMessageFilter'
                }
              },
              processing_settings: {
                client_side_validation: true,
                required: true,
                serialized_name: 'processingSettings',
                type: {
                  name: 'Composite',
                  class_name: 'EdifactProcessingSettings'
                }
              },
              envelope_overrides: {
                client_side_validation: true,
                required: false,
                serialized_name: 'envelopeOverrides',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'EdifactEnvelopeOverrideElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'EdifactEnvelopeOverride'
                      }
                  }
                }
              },
              message_filter_list: {
                client_side_validation: true,
                required: false,
                serialized_name: 'messageFilterList',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'EdifactMessageIdentifierElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'EdifactMessageIdentifier'
                      }
                  }
                }
              },
              schema_references: {
                client_side_validation: true,
                required: true,
                serialized_name: 'schemaReferences',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'EdifactSchemaReferenceElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'EdifactSchemaReference'
                      }
                  }
                }
              },
              validation_overrides: {
                client_side_validation: true,
                required: false,
                serialized_name: 'validationOverrides',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'EdifactValidationOverrideElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'EdifactValidationOverride'
                      }
                  }
                }
              },
              edifact_delimiter_overrides: {
                client_side_validation: true,
                required: false,
                serialized_name: 'edifactDelimiterOverrides',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'EdifactDelimiterOverrideElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'EdifactDelimiterOverride'
                      }
                  }
                }
              }
            }
          }
        }
      end
    end
  end
end
