# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::Logic::Mgmt::V2018_07_01_preview
  module Models
    #
    # The operation result definition.
    #
    class OperationResult < OperationResultProperties

      include MsRestAzure

      # @return [String] Gets the tracking id.
      attr_accessor :tracking_id

      # @return Gets the inputs.
      attr_accessor :inputs

      # @return [ContentLink] Gets the link to inputs.
      attr_accessor :inputs_link

      # @return Gets the outputs.
      attr_accessor :outputs

      # @return [ContentLink] Gets the link to outputs.
      attr_accessor :outputs_link

      # @return Gets the tracked properties.
      attr_accessor :tracked_properties

      # @return [Array<RetryHistory>] Gets the retry histories.
      attr_accessor :retry_history

      # @return [Integer]
      attr_accessor :iteration_count


      #
      # Mapper for OperationResult class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'OperationResult',
          type: {
            name: 'Composite',
            class_name: 'OperationResult',
            model_properties: {
              start_time: {
                client_side_validation: true,
                required: false,
                serialized_name: 'startTime',
                type: {
                  name: 'DateTime'
                }
              },
              end_time: {
                client_side_validation: true,
                required: false,
                serialized_name: 'endTime',
                type: {
                  name: 'DateTime'
                }
              },
              correlation: {
                client_side_validation: true,
                required: false,
                serialized_name: 'correlation',
                type: {
                  name: 'Composite',
                  class_name: 'RunActionCorrelation'
                }
              },
              status: {
                client_side_validation: true,
                required: false,
                serialized_name: 'status',
                type: {
                  name: 'String'
                }
              },
              code: {
                client_side_validation: true,
                required: false,
                serialized_name: 'code',
                type: {
                  name: 'String'
                }
              },
              error: {
                client_side_validation: true,
                required: false,
                serialized_name: 'error',
                type: {
                  name: 'Object'
                }
              },
              tracking_id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'trackingId',
                type: {
                  name: 'String'
                }
              },
              inputs: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'inputs',
                type: {
                  name: 'Object'
                }
              },
              inputs_link: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'inputsLink',
                type: {
                  name: 'Composite',
                  class_name: 'ContentLink'
                }
              },
              outputs: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'outputs',
                type: {
                  name: 'Object'
                }
              },
              outputs_link: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'outputsLink',
                type: {
                  name: 'Composite',
                  class_name: 'ContentLink'
                }
              },
              tracked_properties: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'trackedProperties',
                type: {
                  name: 'Object'
                }
              },
              retry_history: {
                client_side_validation: true,
                required: false,
                serialized_name: 'retryHistory',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'RetryHistoryElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'RetryHistory'
                      }
                  }
                }
              },
              iteration_count: {
                client_side_validation: true,
                required: false,
                serialized_name: 'iterationCount',
                type: {
                  name: 'Number'
                }
              }
            }
          }
        }
      end
    end
  end
end
